# smooster command line tool

This is a ruby gem

## Installation

    $ gem install smooster

  get your api key from http://cms.smooster.com/api_keys

    $ smooster register THIS_SHOULD_BE_YOUR_PERSONAL_API_KEY

## Usage

  Type smooster in terminal for usage info

    $ smooster

  To add a new project navigate to your local folder with the new smooster html project

    $ cd ~/my_html_project/

    $ smooster setup THIS_SHOULD_BE_YOUR_SITE_ID

    $ smooster deploy


## Documentation smooster commands

### Site settings

  Site settings like images sizes, text formation, hosting can be set with 'smooster configure' in site_config.yml
  Just open the site_config.yml and edit to your needs, after that process:

    $ smooster configure

#### Hosting settings:
  IMPORTANT: changing this settings will not affect the online status of your website. If you want your website live, please set the changes and then activate the website via the web interface.

  defaults are:
    hosting:
        type: draft

  ftp hosting:
    hosting:
        type: ftp
        server: ftp.domain.com
        port: 21
        username: myUsername
        password: thepassword
        path: /were/my/files/are/

  smooster hosting:
    hosting:
        type: smo_hosting

#### html suffix for url
  with setting "page_suffix_html" to true smooster will automaticaly add the html suffix to each internal page url
  page_suffix_html: true

## Running tests

    bundle exec rake

## Wishlist
* A wizard for project for new sites - best case even creates a new site in smooster before deployment
* Detecting liquid variables in site_templates an auto activating liquid feature
* add subtemplate feature - auto detect similar parts in html and create subtemplates
* Create a new local project based on the smooster-html-boilerplate
* Create a local project based on a demo website - ready to deploy (for beginners, to see how it may work)
* site_config file for image and formating settings
* making the script windows ready
* deploy a single file like this smooster deploy media/js/functions.js

## Changelog

###0.4.3
* Bugfix: Purging the assets locally produced errors with the new cdn77

###0.4.2
* Bugfix: Checking folder names for unsupported characters before upload
* Bugfix: Checking page titles for unsupported characters before upload

###0.4.1
* Feature: Setting the hosting for the website

###0.3.9
* minor Bugfix
* updated readme (in 0.3.7)

###0.3.6
* added smooster site config file for image size, blockformat and rss settings

###0.3.1
* added NEW smooster setup command to setup a new site
* renamed smooster setup to smooster register

###0.2.1
* Added Page create feature. smooster deploy initial will first upload medias, templates and then create a page for each uploaded template

###0.1.8
* MAJOR: Changed smooster api v2 for site_templates and media_assets from ids to smo_ids

###0.1.7
* Bugfix: use only short_path as reference for site_templates and media_assets (do be more compatible between different users systems)

###0.1.6
* Bugfix: smooster setup failed, if .smo Dir doesn't exist in users homedir

###0.1.2
* Uploading assets first
* Enhanced deploy command default is assets only. options are assets, templates, all

###0.1.1
* Added a setup wizard for the users api_key
* Added a setup wizard for new projects / sites
* Minor improvements to configuration

###0.1.0
* upload or update files in html folder to site_templates in smooster
* upload or update files in media folder to media_assets in smooster (including creating needed folder structure)

## Contributing

1. Fork it ( https://github.com/[my-github-username]/smooster/fork )
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create a new Pull Request
